# -*- coding: utf-8 -*-
# WARNING: This file has been dynamically generated, don\t edit it!
"""
B2UConverter — UNO extension for OpenOffice.org and LibreOffice
File: include/openoffice/header.py

Copyright ©2009  Ministry of Science and Technology of Vietnam
License: GNU Lesser General Public License version 2.1
Authors: Jean Christophe André <jcandre@hanoilug.org>
         Lê Quốc Thái <lqthai@hanoilug.org>
         Võ Đức Phương <vdphuong@hanoilug.org>
         Hoàng Minh Thắng <hoangminhthang@ktqd.org>
"""

import sys
import logging
import traceback

"""
B2UConverter — UNO extension for OpenOffice.org and LibreOffice
File: include/openoffice/encodings_header.py

Copyright ©2009  Ministry of Science and Technology of Vietnam
License: GNU Lesser General Public License version 2.1
Authors: Jean Christophe André <jcandre@hanoilug.org>
         Lê Quốc Thái <lqthai@hanoilug.org>
         Võ Đức Phương <vdphuong@hanoilug.org>
"""

import codecs

# codecs.charmap_build lacks in the Python 2.3.4 bundled with Windows's OOo
if not 'charmap_build' in codecs.__dict__:
    # this code has been "stolen" from Python 2.5 codecs.py
    def _encoding_map_from_decoding_table(table):
        m = {}
        for k,v in list(table.items()):
            if not v in m:
                m[v] = k
            else:
                m[v] = None
        return m

    codecs.charmap_build = _encoding_map_from_decoding_table

""" Python Character Mapping Codec vntime_tcvn (.VnTime font - Vietnamese)
                        (kind of TCVN 5712:1993 VN3 with CP1252 additions)
    Copyright (c) 2008-2009  Jean Christophe André <jcandre@hanoilug.org>
    License: GNU Lesser General Public License version 2.1
    To enable this encoding, move this file into /usr/lib/python2.5/encodings/
"""

vntime_tcvn_decoding_table = (
    '\x00'     #  0x00 -> NULL (NUL)
    '\x01'     #  0x01
    '\x02'     #  0x02
    '\x03'     #  0x03 -> END OF TEXT
    '\x04'     #  0x04
    '\x05'     #  0x05
    '\x06'     #  0x06
    '\x07'     #  0x07 -> BELL (BEL)
    '\x08'     #  0x08 -> BACKSPACE (BS)
    '\x09'     #  0x09 -> CHARACTER TABULATION (HT)
    '\x0A'     #  0x0a -> LINE FEED (LF)
    '\x0B'     #  0x0b -> LINE TABULATION (VT)
    '\x0C'     #  0x0c -> FORM FEED (FF)
    '\x0D'     #  0x0d -> CARRIAGE RETURN (CR)
    '\x0E'     #  0x0e -> SHIFT OUT (SO)
    '\x0F'     #  0x0f -> SHIFT IN (SI)
    '\x10'     #  0x10 -> DATA LINK ESCAPE (DLE)
    '\x11'     #  0x11
    '\x12'     #  0x12
    '\x13'     #  0x13
    '\x14'     #  0x14
    '\x15'     #  0x15
    '\x16'     #  0x16
    '\x17'     #  0x17
    '\x18'     #  0x18 -> CANCEL (CAN)
    '\x19'     #  0x19 -> END OF MEDIUM (EM)
    '\x1A'     #  0x1a -> SUBSTITUTE (SUB)
    '\x1B'     #  0x1b -> ESCAPE (ESC)
    '\x1C'     #  0x1c -> FILE SEPARATOR (IS4)
    '\x1D'     #  0x1d -> GROUP SEPARATOR (IS3)
    '\x1E'     #  0x1e -> RECORD SEPARATOR (IS2)
    '\x1F'     #  0x1f -> UNIT SEPARATOR (IS1)
    ' '        #  0x20 -> SPACE
    '!'        #  0x21 -> EXCLAMATION MARK
    '"'        #  0x22 -> QUOTATION MARK
    '#'        #  0x23 -> NUMBER SIGN
    '$'        #  0x24 -> DOLLAR SIGN
    '%'        #  0x25 -> PERCENT SIGN
    '&'        #  0x26 -> AMPERSAND
    "'"        #  0x27 -> APOSTROPHE
    '('        #  0x28 -> LEFT PARENTHESIS
    ')'        #  0x29 -> RIGHT PARENTHESIS
    '*'        #  0x2A -> ASTERISK
    '+'        #  0x2B -> PLUS SIGN
    ','        #  0x2C -> COMMA
    '-'        #  0x2D -> HYPHEN-MINUS
    '.'        #  0x2E -> FULL STOP
    '/'        #  0x2F -> SOLIDUS
    '0'        #  0x30 -> DIGIT ZERO
    '1'        #  0x31 -> DIGIT ONE
    '2'        #  0x32 -> DIGIT TWO
    '3'        #  0x33 -> DIGIT THREE
    '4'        #  0x34 -> DIGIT FOUR
    '5'        #  0x35 -> DIGIT FIVE
    '6'        #  0x36 -> DIGIT SIX
    '7'        #  0x37 -> DIGIT SEVEN
    '8'        #  0x38 -> DIGIT EIGHT
    '9'        #  0x39 -> DIGIT NINE
    ':'        #  0x3A -> COLON
    ';'        #  0x3B -> SEMICOLON
    '<'        #  0x3C -> LESS-THAN SIGN
    '='        #  0x3D -> EQUALS SIGN
    '>'        #  0x3E -> GREATER-THAN SIGN
    '?'        #  0x3F -> QUESTION MARK
    '@'        #  0x40 -> COMMERCIAL AT
    'A'        #  0x41 -> LATIN CAPITAL LETTER A
    'B'        #  0x42 -> LATIN CAPITAL LETTER B
    'C'        #  0x43 -> LATIN CAPITAL LETTER C
    'D'        #  0x44 -> LATIN CAPITAL LETTER D
    'E'        #  0x45 -> LATIN CAPITAL LETTER E
    'F'        #  0x46 -> LATIN CAPITAL LETTER F
    'G'        #  0x47 -> LATIN CAPITAL LETTER G
    'H'        #  0x48 -> LATIN CAPITAL LETTER H
    'I'        #  0x49 -> LATIN CAPITAL LETTER I
    'J'        #  0x4A -> LATIN CAPITAL LETTER J
    'K'        #  0x4B -> LATIN CAPITAL LETTER K
    'L'        #  0x4C -> LATIN CAPITAL LETTER L
    'M'        #  0x4D -> LATIN CAPITAL LETTER M
    'N'        #  0x4E -> LATIN CAPITAL LETTER N
    'O'        #  0x4F -> LATIN CAPITAL LETTER O
    'P'        #  0x50 -> LATIN CAPITAL LETTER P
    'Q'        #  0x51 -> LATIN CAPITAL LETTER Q
    'R'        #  0x52 -> LATIN CAPITAL LETTER R
    'S'        #  0x53 -> LATIN CAPITAL LETTER S
    'T'        #  0x54 -> LATIN CAPITAL LETTER T
    'U'        #  0x55 -> LATIN CAPITAL LETTER U
    'V'        #  0x56 -> LATIN CAPITAL LETTER V
    'W'        #  0x57 -> LATIN CAPITAL LETTER W
    'X'        #  0x58 -> LATIN CAPITAL LETTER X
    'Y'        #  0x59 -> LATIN CAPITAL LETTER Y
    'Z'        #  0x5A -> LATIN CAPITAL LETTER Z
    '['        #  0x5B -> LEFT SQUARE BRACKET
    '\\'       #  0x5C -> REVERSE SOLIDUS
    ']'        #  0x5D -> RIGHT SQUARE BRACKET
    '^'        #  0x5E -> CIRCUMFLEX ACCENT
    '_'        #  0x5F -> LOW LINE
    '`'        #  0x60 -> GRAVE ACCENT
    'a'        #  0x61 -> LATIN SMALL LETTER A
    'b'        #  0x62 -> LATIN SMALL LETTER B
    'c'        #  0x63 -> LATIN SMALL LETTER C
    'd'        #  0x64 -> LATIN SMALL LETTER D
    'e'        #  0x65 -> LATIN SMALL LETTER E
    'f'        #  0x66 -> LATIN SMALL LETTER F
    'g'        #  0x67 -> LATIN SMALL LETTER G
    'h'        #  0x68 -> LATIN SMALL LETTER H
    'i'        #  0x69 -> LATIN SMALL LETTER I
    'j'        #  0x6A -> LATIN SMALL LETTER J
    'k'        #  0x6B -> LATIN SMALL LETTER K
    'l'        #  0x6C -> LATIN SMALL LETTER L
    'm'        #  0x6D -> LATIN SMALL LETTER M
    'n'        #  0x6E -> LATIN SMALL LETTER N
    'o'        #  0x6F -> LATIN SMALL LETTER O
    'p'        #  0x70 -> LATIN SMALL LETTER P
    'q'        #  0x71 -> LATIN SMALL LETTER Q
    'r'        #  0x72 -> LATIN SMALL LETTER R
    's'        #  0x73 -> LATIN SMALL LETTER S
    't'        #  0x74 -> LATIN SMALL LETTER T
    'u'        #  0x75 -> LATIN SMALL LETTER U
    'v'        #  0x76 -> LATIN SMALL LETTER V
    'w'        #  0x77 -> LATIN SMALL LETTER W
    'x'        #  0x78 -> LATIN SMALL LETTER X
    'y'        #  0x79 -> LATIN SMALL LETTER Y
    'z'        #  0x7A -> LATIN SMALL LETTER Z
    '{'        #  0x7B -> LEFT CURLY BRACKET
    '|'        #  0x7C -> VERTICAL LINE
    '}'        #  0x7D -> RIGHT CURLY BRACKET
    '~'        #  0x7E -> TILDE
    '\x7F'     #  0x7f -> DELETE (DEL)
    '\x80'     #  0x80
    '\x81'     #  0x81
    '\x82'     #  0x82
    '\x83'     #  0x83
    '\x84'     #  0x84
    '\u2026'   #  0x85 -> HORIZONTAL ELLIPSIS
    '\xC7'     #  0x86 -> LATIN CAPITAL LETTER C WITH CEDILLA
    '\x87'     #  0x87
    '\xCB'     #  0x88 -> LATIN CAPITAL LETTER E WITH DIAERESIS
    '\xCA'     #  0x89 -> LATIN CAPITAL LETTER E WITH CIRCUMFLEX
    '\xCF'     #  0x8a -> LATIN CAPITAL LETTER I WITH DIAERESIS
    '\xCE'     #  0x8b -> LATIN CAPITAL LETTER I WITH CIRCUMFLEX
    '\x8C'     #  0x8c
    '\x8D'     #  0x8d
    '\x8E'     #  0x8e
    '\x8F'     #  0x8f
    '\x90'     #  0x90
    '\u2018'   #  0x91 -> LEFT SINGLE QUOTATION MARK
    '\u2019'   #  0x92 -> RIGHT SINGLE QUOTATION MARK
    '\u201c'   #  0x93 -> LEFT DOUBLE QUOTATION MARK
    '\u201d'   #  0x94 -> RIGHT DOUBLE QUOTATION MARK
    '\u2022'   #  0x95 -> BULLET
    '\u2013'   #  0x96 -> EN DASH
    '\u2014'   #  0x97 -> EM DASH
    '\x98'     #  0x98
    '\x99'     #  0x99
    '\xDC'     #  0x9a -> LATIN CAPITAL LETTER U WITH DIAERESIS
    '\xDB'     #  0x9b -> LATIN CAPITAL LETTER U WITH CIRCUMFLEX
    '\x9C'     #  0x9c
    '\x9D'     #  0x9d
    '\x9E'     #  0x9e
    '\x9F'     #  0x9f
    '\xA0'     #  0xa0 -> NO-BREAK SPACE
    '\u0102'   #  0xa1 -> LATIN CAPITAL LETTER A WITH BREVE
    '\xC2'     #  0xa2 -> LATIN CAPITAL LETTER A WITH CIRCUMFLEX
    '\xCA'     #  0xa3 -> LATIN CAPITAL LETTER E WITH CIRCUMFLEX
    '\xD4'     #  0xa4 -> LATIN CAPITAL LETTER O WITH CIRCUMFLEX
    '\u01A0'   #  0xa5 -> LATIN CAPITAL LETTER O WITH HORN
    '\u01AF'   #  0xa6 -> LATIN CAPITAL LETTER U WITH HORN
    '\u0110'   #  0xa7 -> LATIN CAPITAL LETTER D WITH STROKE
    '\u0103'   #  0xa8 -> LATIN SMALL LETTER A WITH BREVE
    '\xE2'     #  0xa9 -> LATIN SMALL LETTER A WITH CIRCUMFLEX
    '\xEA'     #  0xaa -> LATIN SMALL LETTER E WITH CIRCUMFLEX
    '\xF4'     #  0xab -> LATIN SMALL LETTER O WITH CIRCUMFLEX
    '\u01A1'   #  0xac -> LATIN SMALL LETTER O WITH HORN
    '\u01B0'   #  0xad -> LATIN SMALL LETTER U WITH HORN
    '\u0111'   #  0xae -> LATIN SMALL LETTER D WITH STROKE
    '\xAF'     #  0xaf
    '\xB0'     #  0xb0
    '\xB1'     #  0xb1
    '\xB2'     #  0xb2
    '\xB3'     #  0xb3
    '\xB4'     #  0xb4
    '\xE0'     #  0xb5 -> LATIN SMALL LETTER A WITH GRAVE
    '\u1EA3'   #  0xb6 -> LATIN SMALL LETTER A WITH HOOK ABOVE
    '\xE3'     #  0xb7 -> LATIN SMALL LETTER A WITH TILDE
    '\xE1'     #  0xb8 -> LATIN SMALL LETTER A WITH ACUTE
    '\u1EA1'   #  0xb9 -> LATIN SMALL LETTER A WITH DOT BELOW
    '\xBA'     #  0xba
    '\u1EB1'   #  0xbb -> LATIN SMALL LETTER A WITH BREVE AND GRAVE
    '\u1EB3'   #  0xbc -> LATIN SMALL LETTER A WITH BREVE AND HOOK ABOVE
    '\u1EB5'   #  0xbd -> LATIN SMALL LETTER A WITH BREVE AND TILDE
    '\u1EAF'   #  0xbe -> LATIN SMALL LETTER A WITH BREVE AND ACUTE
    '\xBF'     #  0xbf
    '\u1EBB'   #  0xc0 -> LATIN SMALL LETTER E WITH HOOK ABOVE
    '\u1EBD'   #  0xc1 -> LATIN SMALL LETTER E WITH TILDE
    '\u1EB9'   #  0xc2 -> LATIN SMALL LETTER E WITH DOT BELOW
    '\xEB'     #  0xc3 -> LATIN SMALL LETTER E WITH DIAERESIS
    '\u0192'   #  0xc4 -> LATIN SMALL LETTER F WITH HOOK
    '\xC5'     #  0xc5
    '\u1EB7'   #  0xc6 -> LATIN SMALL LETTER A WITH BREVE AND DOT BELOW
    '\u1EA7'   #  0xc7 -> LATIN SMALL LETTER A WITH CIRCUMFLEX AND GRAVE
    '\u1EA9'   #  0xc8 -> LATIN SMALL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE
    '\u1EAB'   #  0xc9 -> LATIN SMALL LETTER A WITH CIRCUMFLEX AND TILDE
    '\u1EA5'   #  0xca -> LATIN SMALL LETTER A WITH CIRCUMFLEX AND ACUTE
    '\u1EAD'   #  0xcb -> LATIN SMALL LETTER A WITH CIRCUMFLEX AND DOT BELOW
    '\xE8'     #  0xcc -> LATIN SMALL LETTER E WITH GRAVE
    '\xCD'     #  0xcd
    '\u1EBB'   #  0xce -> LATIN SMALL LETTER E WITH HOOK ABOVE
    '\u1EBD'   #  0xcf -> LATIN SMALL LETTER E WITH TILDE
    '\xE9'     #  0xd0 -> LATIN SMALL LETTER E WITH ACUTE
    '\u1EB9'   #  0xd1 -> LATIN SMALL LETTER E WITH DOT BELOW
    '\u1EC1'   #  0xd2 -> LATIN SMALL LETTER E WITH CIRCUMFLEX AND GRAVE
    '\u1EC3'   #  0xd3 -> LATIN SMALL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE
    '\u1EC5'   #  0xd4 -> LATIN SMALL LETTER E WITH CIRCUMFLEX AND TILDE
    '\u1EBF'   #  0xd5 -> LATIN SMALL LETTER E WITH CIRCUMFLEX AND ACUTE
    '\u1EC7'   #  0xd6 -> LATIN SMALL LETTER E WITH CIRCUMFLEX AND DOT BELOW
    '\xEC'     #  0xd7 -> LATIN SMALL LETTER I WITH GRAVE
    '\u1EC9'   #  0xd8 -> LATIN SMALL LETTER I WITH HOOK ABOVE
    '\xD9'     #  0xd9
    '\xEF'     #  0xda -> LATIN SMALL LETTER I WITH DIAERESIS
    '\xEE'     #  0xdb -> LATIN SMALL LETTER I WITH CIRCUMFLEX
    '\u0129'   #  0xdc -> LATIN SMALL LETTER I WITH TILDE
    '\xED'     #  0xdd -> LATIN SMALL LETTER I WITH ACUTE
    '\u1ECB'   #  0xde -> LATIN SMALL LETTER I WITH DOT BELOW
    '\xF2'     #  0xdf -> LATIN SMALL LETTER O WITH GRAVE
    '\xE0'     #  0xe0
    '\u1ECF'   #  0xe1 -> LATIN SMALL LETTER O WITH HOOK ABOVE
    '\xF5'     #  0xe2 -> LATIN SMALL LETTER O WITH TILDE
    '\xF3'     #  0xe3 -> LATIN SMALL LETTER O WITH ACUTE
    '\u1ECD'   #  0xe4 -> LATIN SMALL LETTER O WITH DOT BELOW
    '\u1ED3'   #  0xe5 -> LATIN SMALL LETTER O WITH CIRCUMFLEX AND GRAVE
    '\u1ED5'   #  0xe6 -> LATIN SMALL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE
    '\u1ED7'   #  0xe7 -> LATIN SMALL LETTER O WITH CIRCUMFLEX AND TILDE
    '\u1ED1'   #  0xe8 -> LATIN SMALL LETTER O WITH CIRCUMFLEX AND ACUTE
    '\u1ED9'   #  0xe9 -> LATIN SMALL LETTER O WITH CIRCUMFLEX AND DOT BELOW
    '\u1EDD'   #  0xea -> LATIN SMALL LETTER O WITH HORN AND GRAVE
    '\u1EDF'   #  0xeb -> LATIN SMALL LETTER O WITH HORN AND HOOK ABOVE
    '\u1EE1'   #  0xec -> LATIN SMALL LETTER O WITH HORN AND TILDE
    '\u1EDB'   #  0xed -> LATIN SMALL LETTER O WITH HORN AND ACUTE
    '\u1EE3'   #  0xee -> LATIN SMALL LETTER O WITH HORN AND DOT BELOW
    '\xF9'     #  0xef -> LATIN SMALL LETTER U WITH GRAVE
    '\xF0'     #  0xf0
    '\u1EE7'   #  0xf1 -> LATIN SMALL LETTER U WITH HOOK ABOVE
    '\u0169'   #  0xf2 -> LATIN SMALL LETTER U WITH TILDE
    '\xFA'     #  0xf3 -> LATIN SMALL LETTER U WITH ACUTE
    '\u1EE5'   #  0xf4 -> LATIN SMALL LETTER U WITH DOT BELOW
    '\u1EEB'   #  0xf5 -> LATIN SMALL LETTER U WITH HORN AND GRAVE
    '\u1EED'   #  0xf6 -> LATIN SMALL LETTER U WITH HORN AND HOOK ABOVE
    '\u1EEF'   #  0xf7 -> LATIN SMALL LETTER U WITH HORN AND TILDE
    '\u1EE9'   #  0xf8 -> LATIN SMALL LETTER U WITH HORN AND ACUTE
    '\u1EF1'   #  0xf9 -> LATIN SMALL LETTER U WITH HORN AND DOT BELOW
    '\u1EF3'   #  0xfa -> LATIN SMALL LETTER Y WITH GRAVE
    '\u1EF7'   #  0xfb -> LATIN SMALL LETTER Y WITH HOOK ABOVE
    '\u1EF9'   #  0xfc -> LATIN SMALL LETTER Y WITH TILDE
    '\xFD'     #  0xfd -> LATIN SMALL LETTER Y WITH ACUTE
    '\u1EF5'   #  0xfe -> LATIN SMALL LETTER Y WITH DOT BELOW
    '\xFF'     #  0xff
)

vntime_tcvn_encoding_map = codecs.charmap_build(vntime_tcvn_decoding_table)

def vntime_tcvn_decode(input, errors='strict'):
    return codecs.charmap_decode(input, errors, vntime_tcvn_decoding_table)

def vntime_tcvn_encode(input, errors='strict'):
    return codecs.charmap_encode(input, errors, vntime_tcvn_encoding_map)

""" Python Character Mapping Codec vni (VNI Software Company - Vietnamese)
    Copyright (c) 2008-2009  Jean Christophe André <jcandre@hanoilug.org>
    License: GNU Lesser General Public License version 2.1
    To enable this encoding, move this file into /usr/lib/python2.5/encodings/

    Created from information found at http://vnisoft.com/english/vnichar.htm

    WARNING: THE ENCODING IS UNFINISHED YET !!! (READ *NOT* WORKING)
"""

def _create_vni_secondhalf_decoding_table():
    _decoding_table = {}
    ### MISC
    _decoding_table['\x80'] = '\uFFFE' # UNDEFINED
    _decoding_table['\x81'] = '\uFFFE' # UNDEFINED
    _decoding_table['\x82'] = '\xC6' # CAPITAL AE
    _decoding_table['\x83'] = '\u0192' # SMALL F WITH HOOK
    _decoding_table['\x84'] = '\xE6' # SMALL AE
    _decoding_table['\x85'] = '\u2026' # HORIZONTAL ELLIPSIS
    _decoding_table['\x86'] = '\u2020' # DAGGER
    _decoding_table['\x87'] = '\u2021' # DOUBLE DAGGER
    _decoding_table['\x88'] = '\uFFFE' # FIXME: UNKNOWN
    _decoding_table['\x89'] = '\u2030' # PER MILLE SIGN
    _decoding_table['\x8A'] = '\uFFFE' # FIXME: DIAERESIS ABOVE FOR CAPITAL
    _decoding_table['\x8B'] = '\u2039' # SINGLE LEFT-POINTING ANGLE QUOTATION MARK
    _decoding_table['\x8C'] = '\uFFFE' # FIXME: HOOK ABOVE FOR CAPITAL (also \xDB)
    _decoding_table['\x8D'] = '\uFFFE' # UNDEFINED
    _decoding_table['\x8E'] = '\uFFFE' # FIXME: UNKNOWN
    _decoding_table['\x8F'] = '\uFFFE' # UNDEFINED
    _decoding_table['\x90'] = '\uFFFE' # UNDEFINED
    _decoding_table['\x91'] = '\u2018' # LEFT SINGLE QUOTATION MARK
    _decoding_table['\x92'] = '\u2019' # RIGHT SINGLE QUOTATION MARK
    _decoding_table['\x93'] = '\u201C' # LEFT DOUBLE QUOTATION MARK
    _decoding_table['\x94'] = '\u201D' # RIGHT DOUBLE QUOTATION MARK
    _decoding_table['\x95'] = '\uFFFE' # FIXME: UNKNOWN
    _decoding_table['\x96'] = '\u2013' # EN DASH
    _decoding_table['\x97'] = '\u2014' # EM DASH
    _decoding_table['\x98'] = '\uFFFE' # FIXME: UNKNOWN
    _decoding_table['\x99'] = '\u2122' # TRADE MARK SIGN
    _decoding_table['\x9A'] = '\uFFFE' # FIXME: DIAERESIS ABOVE FOR SMALL
    _decoding_table['\x9B'] = '\u203A' # SINGLE RIGHT-POINTING ANGLE QUOTATION MARK
    _decoding_table['\x9C'] = '\uFFFE' # FIXME: HOOK ABOVE FOR SMALL (also \xFB)
    _decoding_table['\x9D'] = '\uFFFE' # UNDEFINED
    _decoding_table['\x9E'] = '\uFFFE' # FIXME: UNKNOWN
    _decoding_table['\x9F'] = '\u1EF4' # CAPITAL Y WITH DOT BELOW (also \xCE)
    _decoding_table['\xA0'] = '\xA0' # UNICODE
    _decoding_table['\xA1'] = '\xA1' # UNICODE
    _decoding_table['\xA2'] = '\xA2' # UNICODE
    _decoding_table['\xA3'] = '\xA3' # UNICODE
    _decoding_table['\xA4'] = '\xA4' # UNICODE
    _decoding_table['\xA5'] = '\xA5' # UNICODE
    _decoding_table['\xA6'] = '\xA6' # UNICODE
    _decoding_table['\xA7'] = '\xA7' # UNICODE
    _decoding_table['\xA8'] = '\uFFFE' # FIXME: RING ABOVE FOR CAPITAL
    _decoding_table['\xA9'] = '\xA9' # UNICODE
    _decoding_table['\xAA'] = '\uFFFE' # FIXME: PLAIN SQUARE
    _decoding_table['\xAB'] = '\xAB' # UNICODE
    _decoding_table['\xAC'] = '\u0152' # CAPITAL LIGATURE OE
    _decoding_table['\xAD'] = '\xAD' # UNICODE
    _decoding_table['\xAE'] = '\xAE' # UNICODE
    _decoding_table['\xAF'] = '\xAF' # UNICODE
    _decoding_table['\xB0'] = '\uFFFE' # FIXME: PLAIN CIRCLE
    _decoding_table['\xB1'] = '\xB1' # UNICODE
    _decoding_table['\xB2'] = '\xB2' # UNICODE
    _decoding_table['\xB3'] = '\xB3' # UNICODE
    _decoding_table['\xB4'] = '\uFFFE' # FIXME: CARON ABOVE FOR CAPITAL
    _decoding_table['\xB5'] = '\xB5' # UNICODE
    _decoding_table['\xB6'] = '\xB6' # UNICODE
    _decoding_table['\xB7'] = '\uFFFE' # FIXME: RING ABOVE FOR SMALL
    _decoding_table['\xB8'] = '\uFFFE' # FIXME: CARON ABOVE FOR SMALL
    _decoding_table['\xB9'] = '\xB9' # UNICODE
    _decoding_table['\xBA'] = '\uFFFE' # FIXME: EMPTY SQUARE
    _decoding_table['\xBB'] = '\xBB' # UNICODE
    _decoding_table['\xBC'] = '\xBC' # UNICODE
    _decoding_table['\xBD'] = '\xBD' # UNICODE
    _decoding_table['\xBE'] = '\xBE' # UNICODE
    _decoding_table['\xBF'] = '\xBF' # UNICODE
    ### CAPITAL LETTERS
    _decoding_table['\xC0'] = {
        'A':    '\u1EA6', # CAPITAL A WITH CIRCUMFLEX AND GRAVE
        'E':    '\u1EC0', # CAPITAL E WITH CIRCUMFLEX AND GRAVE
        'O':    '\u1ED2', # CAPITAL O WITH CIRCUMFLEX AND GRAVE
    }
    _decoding_table['\xC1'] = {
        'A':    '\u1EA4', # CAPITAL A WITH CIRCUMFLEX AND ACUTE
        'E':    '\u1EBE', # CAPITAL E WITH CIRCUMFLEX AND ACUTE
        'O':    '\u1ED0', # CAPITAL O WITH CIRCUMFLEX AND ACUTE
    }
    _decoding_table['\xC2'] = {
        'A':    '\u00C2', # CAPITAL A WITH CIRCUMFLEX
        'E':    '\u00CA', # CAPITAL E WITH CIRCUMFLEX
        'I':    '\u00CE', # CAPITAL I WITH CIRCUMFLEX # XXX: unused because of \xDD ?
        'O':    '\u00D4', # CAPITAL O WITH CIRCUMFLEX
    }
    _decoding_table['\xC3'] = {
        'A':    '\u1EAA', # CAPITAL A WITH CIRCUMFLEX AND TILDE
        'E':    '\u1EC4', # CAPITAL E WITH CIRCUMFLEX AND TILDE
        'O':    '\u1ED6', # CAPITAL O WITH CIRCUMFLEX AND TILDE
    }
    _decoding_table['\xC4'] = {
        'A':    '\u1EAC', # CAPITAL A WITH CIRCUMFLEX AND DOT BELOW
        'E':    '\u1EC6', # CAPITAL E WITH CIRCUMFLEX AND DOT BELOW
        'O':    '\u1ED8', # CAPITAL O WITH CIRCUMFLEX AND DOT BELOW
    }
    _decoding_table['\xC5'] = {
        'A':    '\u1EA8', # CAPITAL A WITH CIRCUMFLEX AND HOOK
        'E':    '\u1EC2', # CAPITAL E WITH CIRCUMFLEX AND HOOK
        'O':    '\u1ED4', # CAPITAL O WITH CIRCUMFLEX AND HOOK
    }
    _decoding_table['\xC6'] = '\u1EC8' # CAPITAL I WITH HOOK
    _decoding_table['\xC7'] = '\xC7' # UNICODE
    _decoding_table['\xC8'] = {
        'A':    '\u1EB0', # CAPITAL A WITH BREVE AND GRAVE
    }
    _decoding_table['\xC9'] = {
        'A':    '\u1EAE', # CAPITAL A WITH BREVE AND ACUTE
    }
    _decoding_table['\xCA'] = {
        'A':    '\u0102', # CAPITAL A WITH BREVE
    }
    _decoding_table['\xCB'] = {
        'A':    '\u1EB6', # CAPITAL A WITH BREVE AND DOT BELOW
    }
    _decoding_table['\xCC'] = '\u00CC' # CAPITAL I WITH GRAVE
    _decoding_table['\xCD'] = '\u00CD' # CAPITAL I WITH ACUTE
    _decoding_table['\xCE'] = '\u1EF4' # CAPITAL Y WITH DOT BELOW
    _decoding_table['\xCF'] = {
        'A':    '\u1EA0', # CAPITAL A WITH DOT BELOW
        'E':    '\u1EB8', # CAPITAL E WITH DOT BELOW
        'I':    '\u1ECA', # CAPITAL I WITH DOT BELOW # XXX: unused because of \xD2 ?
        'O':    '\u1ECC', # CAPITAL O WITH DOT BELOW
        '\xD4': '\u1EE2', # CAPITAL O WITH DOT BELOW AND HORN
        'U':    '\u1EE4', # CAPITAL U WITH DOT BELOW
        '\xD6': '\u1EF0', # CAPITAL U WITH DOT BELOW AND HORN
        'Y':    '\u1EF4', # CAPITAL Y WITH DOT BELOW # XXX: unused because of \xCE ?
    }
    _decoding_table['\xD0'] = '\u00CF' # CAPITAL I WITH DIAERESIS
    _decoding_table['\xD1'] = '\u0110' # CAPITAL D WITH STROKE
    _decoding_table['\xD2'] = '\u1ECA' # CAPITAL I WITH DOT BELOW
    _decoding_table['\xD3'] = '\u0128' # CAPITAL I WITH TILDE
    _decoding_table['\xD4'] = '\u01A0' # CAPITAL O WITH HORN
    _decoding_table['\xD5'] = {
        'A':    '\u00C3', # CAPITAL A WITH TILDE
        'E':    '\u1EBC', # CAPITAL E WITH TILDE
        'I':    '\u0128', # CAPITAL I WITH TILDE # XXX: unused because of \xD3 ?
        'O':    '\u00D5', # CAPITAL O WITH TILDE
        '\xD4': '\u1EE0', # CAPITAL O WITH TILDE AND HORN
        'U':    '\u0168', # CAPITAL U WITH TILDE
        '\xD6': '\u1EEE', # CAPITAL U WITH TILDE AND HORN
        'Y':    '\u1EF8', # CAPITAL Y WITH TILDE
    }
    _decoding_table['\xD6'] = '\u01AF' # CAPITAL U WITH HORN
    _decoding_table['\xD7'] = '\xD7' # UNICODE
    _decoding_table['\xD8'] = {
        'A':    '\u00C0', # CAPITAL A WITH GRAVE
        'E':    '\u00C8', # CAPITAL E WITH GRAVE
        'I':    '\u00CC', # CAPITAL I WITH GRAVE # XXX: unused because of \xCC ?
        'O':    '\u00D2', # CAPITAL O WITH GRAVE
        '\xD4': '\u1EDC', # CAPITAL O WITH GRAVE AND HORN
        'U':    '\u00D9', # CAPITAL U WITH GRAVE
        '\xD6': '\u1EEA', # CAPITAL U WITH GRAVE AND HORN
        'Y':    '\u1EF2', # CAPITAL Y WITH GRAVE
    }
    _decoding_table['\xD9'] = {
        'A':    '\u00C1', # CAPITAL A WITH ACUTE
        'E':    '\u00C9', # CAPITAL E WITH ACUTE
        'I':    '\u00CD', # CAPITAL I WITH ACUTE # XXX: unused because of \xCD ?
        'O':    '\u00D3', # CAPITAL O WITH ACUTE
        '\xD4': '\u1EDA', # CAPITAL O WITH ACUTE AND HORN
        'U':    '\u00DA', # CAPITAL U WITH ACUTE
        '\xD6': '\u1EE8', # CAPITAL U WITH ACUTE AND HORN
        'Y':    '\u00DD', # CAPITAL Y WITH ACUTE
    }
    _decoding_table['\xDA'] = {
        'A':    '\u1EB2', # CAPITAL A WITH BREVE AND HOOK
    }
    _decoding_table['\xDB'] = {
        'A':    '\u1EA2', # CAPITAL A WITH HOOK
        'E':    '\u1EBA', # CAPITAL E WITH HOOK
        'I':    '\u1EC8', # CAPITAL I WITH HOOK # XXX: unused because of \xC6 ?
        'O':    '\u1ECE', # CAPITAL O WITH HOOK
        '\xD4': '\u1EDE', # CAPITAL O WITH HOOK AND HORN
        'U':    '\u1EE6', # CAPITAL U WITH HOOK
        '\xD6': '\u1EEC', # CAPITAL U WITH HOOK AND HORN
        'Y':    '\u1EF6', # CAPITAL Y WITH HOOK
    }
    _decoding_table['\xDC'] = {
        'A':    '\u1EB4', # CAPITAL A WITH BREVE AND TILDE
    }
    _decoding_table['\xDD'] = '\u00CE' # CAPITAL I WITH CIRCUMFLEX
    _decoding_table['\xDE'] = '\xDE' # UNICODE
    _decoding_table['\xDF'] = '\xDF' # UNICODE
    ### SMALL LETTERS
    _decoding_table['\xE0'] = {
        'a':    '\u1EA7', # SMALL A WITH CIRCUMFLEX AND GRAVE
        'e':    '\u1EC1', # SMALL E WITH CIRCUMFLEX AND GRAVE
        'o':    '\u1ED3', # SMALL O WITH CIRCUMFLEX AND GRAVE
    }
    _decoding_table['\xE1'] = {
        'a':    '\u1EA5', # SMALL A WITH CIRCUMFLEX AND ACUTE
        'e':    '\u1EBF', # SMALL E WITH CIRCUMFLEX AND ACUTE
        'o':    '\u1ED1', # SMALL O WITH CIRCUMFLEX AND ACUTE
    }
    _decoding_table['\xE2'] = {
        'a':    '\u00E2', # SMALL A WITH CIRCUMFLEX
        'e':    '\u00EA', # SMALL E WITH CIRCUMFLEX
        'i':    '\u00EE', # SMALL I WITH CIRCUMFLEX # XXX: unused because of \xFD ?
        'o':    '\u00F4', # SMALL O WITH CIRCUMFLEX
    }
    _decoding_table['\xE3'] = {
        'a':    '\u1EAB', # SMALL A WITH CIRCUMFLEX AND TILDE
        'e':    '\u1EC5', # SMALL E WITH CIRCUMFLEX AND TILDE
        'o':    '\u1ED7', # SMALL O WITH CIRCUMFLEX AND TILDE
    }
    _decoding_table['\xE4'] = {
        'a':    '\u1EAD', # SMALL A WITH CIRCUMFLEX AND DOT BELOW
        'e':    '\u1EC7', # SMALL E WITH CIRCUMFLEX AND DOT BELOW
        'o':    '\u1ED9', # SMALL O WITH CIRCUMFLEX AND DOT BELOW
    }
    _decoding_table['\xE5'] = {
        'a':    '\u1EA9', # SMALL A WITH CIRCUMFLEX AND HOOK
        'e':    '\u1EC3', # SMALL E WITH CIRCUMFLEX AND HOOK
        'o':    '\u1ED5', # SMALL O WITH CIRCUMFLEX AND HOOK
    }
    _decoding_table['\xE6'] = '\u1EC9' # SMALL I WITH HOOK
    _decoding_table['\xE7'] = '\xE7' # UNICODE
    _decoding_table['\xE8'] = {
        'a':    '\u1EB1', # SMALL A WITH BREVE AND GRAVE
    }
    _decoding_table['\xE9'] = {
        'a':    '\u1EAF', # SMALL A WITH BREVE AND ACUTE
    }
    _decoding_table['\xEA'] = {
        'a':    '\u0103', # SMALL A WITH BREVE
    }
    _decoding_table['\xEB'] = {
        'a':    '\u1EB7', # SMALL A WITH BREVE AND DOT BELOW
    }
    _decoding_table['\xEC'] = '\u00EC' # SMALL I WITH GRAVE
    _decoding_table['\xED'] = '\u00ED' # SMALL I WITH ACUTE
    _decoding_table['\xEE'] = '\u1EF5' # SMALL Y WITH DOT BELOW
    _decoding_table['\xEF'] = {
        'a':    '\u1EA1', # SMALL A WITH DOT BELOW
        'e':    '\u1EB9', # SMALL E WITH DOT BELOW
        'i':    '\u1ECB', # SMALL I WITH DOT BELOW # XXX: unused because of \xF2 ?
        'o':    '\u1ECD', # SMALL O WITH DOT BELOW
        '\xF4': '\u1EE3', # SMALL O WITH DOT BELOW AND HORN
        'u':    '\u1EE5', # SMALL U WITH DOT BELOW
        '\xF6': '\u1EF1', # SMALL U WITH DOT BELOW AND HORN
        'y':    '\u1EF5', # SMALL Y WITH DOT BELOW # XXX: unused because of \xEE ?
    }
    _decoding_table['\xF0'] = '\u00EF' # SMALL I WITH DIAERESIS
    _decoding_table['\xF1'] = '\u0111' # SMALL D WITH STROKE
    _decoding_table['\xF2'] = '\u1ECB' # SMALL I WITH DOT BELOW
    _decoding_table['\xF3'] = '\u0129' # SMALL I WITH TILDE
    _decoding_table['\xF4'] = '\u01A1' # SMALL O WITH HORN
    _decoding_table['\xF5'] = {
        'a':    '\u00E3', # SMALL A WITH TILDE
        'e':    '\u1EBD', # SMALL E WITH TILDE
        'i':    '\u0129', # SMALL I WITH TILDE # XXX: unused because of \xF3 ?
        'o':    '\u00F5', # SMALL O WITH TILDE
        '\xF4': '\u1EE1', # SMALL O WITH TILDE AND HORN
        'u':    '\u0169', # SMALL U WITH TILDE
        '\xF6': '\u1EEF', # SMALL U WITH TILDE AND HORN
        'y':    '\u1EF9', # SMALL Y WITH TILDE
    }
    _decoding_table['\xF6'] = '\u01B0' # SMALL U WITH HORN
    _decoding_table['\xF7'] = '\xF7' # UNICODE
    _decoding_table['\xF8'] = {
        'a':    '\u00E0', # SMALL A WITH GRAVE
        'e':    '\u00E8', # SMALL E WITH GRAVE
        'i':    '\u00EC', # SMALL I WITH GRAVE # XXX: unused because of \xEC ?
        'o':    '\u00F2', # SMALL O WITH GRAVE
        '\xF4': '\u1EDD', # SMALL O WITH GRAVE AND HORN
        'u':    '\u00F9', # SMALL U WITH GRAVE
        '\xF6': '\u1EEB', # SMALL U WITH GRAVE AND HORN
        'y':    '\u1EF3', # SMALL Y WITH GRAVE
    }
    _decoding_table['\xF9'] = {
        'a':    '\u00E1', # SMALL A WITH ACUTE
        'e':    '\u00E9', # SMALL E WITH ACUTE
        'i':    '\u00ED', # SMALL I WITH ACUTE # XXX: unused because of \xED ?
        'o':    '\u00F3', # SMALL O WITH ACUTE
        '\xF4': '\u1EDB', # SMALL O WITH ACUTE AND HORN
        'u':    '\u00FA', # SMALL U WITH ACUTE
        '\xF6': '\u1EE9', # SMALL U WITH ACUTE AND HORN
        'y':    '\u00FD', # SMALL Y WITH ACUTE
    }
    _decoding_table['\xFA'] = {
        'a':    '\u1EB3', # SMALL A WITH BREVE AND HOOK
    }
    _decoding_table['\xFB'] = {
        'a':    '\u1EA3', # SMALL A WITH HOOK
        'e':    '\u1EBB', # SMALL E WITH HOOK
        'i':    '\u1EC9', # SMALL I WITH HOOK # XXX: unused because of \xE6 ?
        'o':    '\u1ECF', # SMALL O WITH HOOK
        '\xF4': '\u1EDF', # SMALL O WITH HOOK AND HORN
        'u':    '\u1EE7', # SMALL U WITH HOOK
        '\xF6': '\u1EED', # SMALL U WITH HOOK AND HORN
        'y':    '\u1EF7', # SMALL Y WITH HOOK
    }
    _decoding_table['\xFC'] = {
        'a':    '\u1EB5', # SMALL A WITH BREVE AND TILDE
    }
    _decoding_table['\xFD'] = '\u00EE' # SMALL I WITH CIRCUMFLEX
    _decoding_table['\xFE'] = '\xFE' # UNICODE
    _decoding_table['\xFF'] = '\u1EF5' # SMALL Y WITH DOT BELOW
    ### SMALL LETTERS ACCENTS APPLIED ON CAPITALS LETTERS (!?) # seen in use...
    for i in range(0xE0, 0xFF):
        if type(_decoding_table[chr(i)]) == dict:
            _decoding_table[chr(i)].update(_decoding_table[chr(i-0x20)])
    ###
    return _decoding_table

_vni_secondhalf_decoding_table = _create_vni_secondhalf_decoding_table()

def vni_decode(input, errors='strict'):
    assert errors == 'strict'
    output = ''
    _decoding_table = _vni_secondhalf_decoding_table
    for i,c in enumerate(input):
        if ord(c) < 0x80:
            output += c
        elif type(_decoding_table[c]) == dict:
            try:
                output = output[:-1] + _decoding_table[c][input[i-1]]
            except KeyError:
                # TODO: return more informative values? (error,position)
                raise ValueError("bad encoded data at position %d" % i)
        else:
            output += _decoding_table[c]
    return (output, len(input))

def vni_encode(input,errors='strict'):
    assert errors == 'strict'
    _encoding_table = {}
    _encoding_table['\u00C0'] = 'A\xD8'
    # FIXME: to continue...
    output = ''
    for c in input:
        if c in _encoding_table:
            output += _encoding_table[c]
        else:
            output += c
    return (output, len(input))

""" Python Character Mapping Codec cp1252 (Microsoft - West European languages)
    Copyright (c) 2008-2009  Jean Christophe André <jcandre@hanoilug.org>
    License: GNU Lesser General Public License version 2.1
    To enable this encoding, move this file into /usr/lib/python2.5/encodings/
"""

def _create_cp1252_to_unicode_table():
    cp1252_begin = ''.join(map(chr,list(range(0,0x80))))
    cp1252_specials = (
        '\u20ac'   #  0x80 -> EURO SIGN
        '\x81'     #  0x81
        '\u201a'   #  0x82 -> SINGLE LOW-9 QUOTATION MARK
        '\u0192'   #  0x83 -> LATIN SMALL LETTER F WITH HOOK
        '\u201e'   #  0x84 -> DOUBLE LOW-9 QUOTATION MARK
        '\u2026'   #  0x85 -> HORIZONTAL ELLIPSIS
        '\u2020'   #  0x86 -> DAGGER
        '\u2021'   #  0x87 -> DOUBLE DAGGER
        '\u02c6'   #  0x88 -> MODIFIER LETTER CIRCUMFLEX ACCENT
        '\u2030'   #  0x89 -> PER MILLE SIGN
        '\u0160'   #  0x8A -> LATIN CAPITAL LETTER S WITH CARON
        '\u2039'   #  0x8B -> SINGLE LEFT-POINTING ANGLE QUOTATION MARK
        '\u0152'   #  0x8C -> LATIN CAPITAL LIGATURE OE
        '\x8D'     #  0x8D
        '\u017d'   #  0x8E -> LATIN CAPITAL LETTER Z WITH CARON
        '\x8F'     #  0x8F
        '\x90'     #  0x90
        '\u2018'   #  0x91 -> LEFT SINGLE QUOTATION MARK
        '\u2019'   #  0x92 -> RIGHT SINGLE QUOTATION MARK
        '\u201c'   #  0x93 -> LEFT DOUBLE QUOTATION MARK
        '\u201d'   #  0x94 -> RIGHT DOUBLE QUOTATION MARK
        '\u2022'   #  0x95 -> BULLET
        '\u2013'   #  0x96 -> EN DASH
        '\u2014'   #  0x97 -> EM DASH
        '\u02dc'   #  0x98 -> SMALL TILDE
        '\u2122'   #  0x99 -> TRADE MARK SIGN
        '\u0161'   #  0x9A -> LATIN SMALL LETTER S WITH CARON
        '\u203a'   #  0x9B -> SINGLE RIGHT-POINTING ANGLE QUOTATION MARK
        '\u0153'   #  0x9C -> LATIN SMALL LIGATURE OE
        '\x9D'     #  0x9D
        '\u017e'   #  0x9E -> LATIN SMALL LETTER Z WITH CARON
        '\u0178'   #  0x9F -> LATIN CAPITAL LETTER Y WITH DIAERESIS
    )
    cp1252_end = ''.join(map(chr,list(range(0xA0,0x100))))
    return cp1252_begin + cp1252_specials + cp1252_end

cp1252_decoding_table = _create_cp1252_to_unicode_table()

"""
B2UConverter — UNO extension for OpenOffice.org and LibreOffice
File: include/openoffice/encodings_footer.py

Copyright ©2009  Ministry of Science and Technology of Vietnam
License: GNU Lesser General Public License version 2.1
Authors: Jean Christophe André <jcandre@hanoilug.org>
         Lê Quốc Thái <lqthai@hanoilug.org>
         Võ Đức Phương <vdphuong@hanoilug.org>
"""

def _privateCodecSearch(name):
    if name == 'internal_vntime_tcvn':
        return (vntime_tcvn_encode, vntime_tcvn_decode, None, None)
    if name == 'internal_vni':
        return (None, vni_decode, None, None)
    return None

# register new/internal codecs
codecs.register(_privateCodecSearch)

"""
B2UConverter — UNO extension for OpenOffice.org and LibreOffice
File: include/vietnamese_recoding.py

Copyright ©2009  Ministry of Science and Technology of Vietnam
License: GNU Lesser General Public License version 2.1
Authors: Jean Christophe André <jcandre@hanoilug.org>
         Lê Quốc Thái <lqthai@hanoilug.org>
         Võ Đức Phương <vdphuong@hanoilug.org>
"""

class VietnameseTextConverter(object):

    _diacritics = (
        #'âÂăĂđĐêÊôÔơƠưƯ'
        '\xe2\xc2\u0103\u0102\u0111\u0110\xea\xca\xf4\xd4\u01a1\u01a0\u01b0\u01af'
        #'áÁàÀảẢãÃạẠấẤầẦẩẨẫẪậẬắẮằẰẳẲẵẴặẶ'
        '\xe1\xc1\xe0\xc0\u1ea3\u1ea2\xe3\xc3\u1ea1\u1ea0\u1ea5\u1ea4\u1ea7\u1ea6\u1ea9\u1ea8\u1eab\u1eaa\u1ead\u1eac\u1eaf\u1eae\u1eb1\u1eb0\u1eb3\u1eb2\u1eb5\u1eb4\u1eb7\u1eb6'
        #'éÉèÈẻẺẽẼẹẸếẾềỀểỂễỄệỆíÍìÌỉỈĩĨịỊ'
        '\xe9\xc9\xe8\xc8\u1ebb\u1eba\u1ebd\u1ebc\u1eb9\u1eb8\u1ebf\u1ebe\u1ec1\u1ec0\u1ec3\u1ec2\u1ec5\u1ec4\u1ec7\u1ec6\xed\xcd\xec\xcc\u1ec9\u1ec8\u0129\u0128\u1ecb\u1eca'
        #'óÓòÒỏỎõÕọỌốỐồỒổỔỗỖộỘớỚờỜởỞỡỠợỢ'
        '\xf3\xd3\xf2\xd2\u1ecf\u1ece\xf5\xd5\u1ecd\u1ecc\u1ed1\u1ed0\u1ed3\u1ed2\u1ed5\u1ed4\u1ed7\u1ed6\u1ed9\u1ed8\u1edb\u1eda\u1edd\u1edc\u1edf\u1ede\u1ee1\u1ee0\u1ee3\u1ee2'
        #'úÚùÙủỦũŨụỤứỨừỪửỬữỮựỰỳỲỷỶỹỸỵỴýÝ'
        '\xfa\xda\xf9\xd9\u1ee7\u1ee6\u0169\u0168\u1ee5\u1ee4\u1ee9\u1ee8\u1eeb\u1eea\u1eed\u1eec\u1eef\u1eee\u1ef1\u1ef0\u1ef3\u1ef2\u1ef7\u1ef6\u1ef9\u1ef8\u1ef5\u1ef4\xfd\xdd'
    )
    _diacritics_removed = (
        'aAaAdDeEoOoOuU'
        'aAaAaAaAaAaAaAaAaAaAaAaAaAaAaA'
        'eEeEeEeEeEeEeEeEeEeEiIiIiIiIiI'
        'oOoOoOoOoOoOoOoOoOoOoOoOoOoOoO'
        'uUuUuUuUuUuUuUuUuUuUyYyYyYyYyY'
    )

    def __init__(self, decoderPrefix=None, vniHacks=False):
        self.decoderPrefix = decoderPrefix and decoderPrefix or ''
        self.vniHacksFlag = vniHacks

    def removeDiacritics(self, str):
        result = ''
        for c in str:
            idx = self._diacritics.find(c)
            if idx >= 0:
                c = self._diacritics_removed[idx]
            result += c
        return result

    def convertString(self, str, real, upper=False):
        if not str: return ''
        result = ''
        prefixed_real = self.decoderPrefix + real

        logging.debug("convertString('%s')", str)
        # compensate for (supposedly) some VNI encoder's bug(s)
        if self.vniHacksFlag and real == 'vni':
            # two consecutive 'Â', 'â', 'å', 'ï', 'ù', 'õ'
            for c in ['\xC2', '\xE2', '\xE5', '\xEF', '\xF5', '\xF9']:
                while (str.find(c * 2) >= 0):
                    str = str.replace(c * 2, c)
            # 'âê' -> 'â'
            while (str.find('\xE2\xEA') >= 0):
                str = str.replace('\xE2\xEA', '\xE2')
            # 'ÀÂ' -> 'À'
            while (str.find('\xC0\xC2') >= 0):
                str = str.replace('\xC0\xC2', '\xC0')
            # 'àø' -> 'à'
            while (str.find('\xE0\xF8') >= 0):
                str = str.replace('\xE0\xF8', '\xE0')
        # Vietnamese case: mix of byte & Unicode chars
        i = 0
        while (i < len(str)):
            # find cp1252 content and convert it
            j = i
            while (j < len(str) and str[j] in cp1252_decoding_table): j += 1
            segment = str[i:j].encode('cp1252').decode(prefixed_real)
            if upper: segment = segment.upper()
            result += segment
            # find Unicode content and keep it
            # XXX: could use this information to detect text already converted!
            k = j
            while (k < len(str) and ord(str[k]) >= 256): k += 1
            result += str[j:k]
            i = k

        # compensate for OOo's bug on MS-Office's soft hyphen importation
        if real == 'vntime_tcvn':
            # luckily there is no Vietnamese word with two consecutive 'ư'
            if upper:
                while (result.find('\u01AF\u01AF') >= 0):
                    result = result.replace('\u01AF\u01AF', '\u01AF')
            else:
                while (result.find('\u01B0\u01B0') >= 0):
                    result = result.replace('\u01B0\u01B0', '\u01B0')

        logging.debug("convertString -> '%s'", result)
        return result

"""
B2UConverter — UNO extension for OpenOffice.org and LibreOffice
File: include/openoffice/document_processing.py

Copyright ©2009  Ministry of Science and Technology of Vietnam
License: GNU Lesser General Public License version 2.1
Authors: Jean Christophe André <jcandre@hanoilug.org>
         Lê Quốc Thái <lqthai@hanoilug.org>
         Võ Đức Phương <vdphuong@hanoilug.org>
         Hoàng Minh Thắng <hoangminhthang@ktqd.org>
"""

import uno
import unohelper
from com.sun.star.lang import Locale
import unicodedata
import re

class OOoVietnameseTextConverter(object):

    def __init__(self, textConverter, removeDiacritics=False, normalizeDiacritics=False):
        self.textConverter = textConverter
        self.removeDiacriticsFlag = removeDiacritics
        self.normalizeDiacriticsFlag = normalizeDiacritics
        self.stats = { 'vntime_tcvn': 0, 'vni': 0 }

    def normalizeDiacritics(self, source, diacriticsPosClassicOn=False):
        TONE = '(['+'\u0300'+'\u0309'+'\u0303'+'\u0301'+'\u0323'+'])'
        result = unicodedata.normalize('NFD',source.replace('\u0110', '\u00D0').replace('\u0111', '\u00F0'))
        result = re.sub('(?i)' + TONE + '([aeiouy' + '\u0306'+'\u0302'+'\u031B]'+'+)', "\\2\\1", result)
        result = re.sub('(?i)(?<=['+'\u0306'+'\u0302'+'\u031B'+'])(.)' + TONE + '\\B', "\\2\\1", result)
        result = re.sub('(?i)(?<=[ae])([iouy])' + TONE, "\\2\\1", result)
        result = re.sub('(?i)(?<=[oy])([iuy])' + TONE, "\\2\\1", result)
        result = re.sub('(?i)(?<!q)(u)([aeiou])' + TONE, "\\1\\3\\2", result)
        result = re.sub('(?i)(?<!g)(i)([aeiouy])' + TONE, "\\1\\3\\2", result)
        if diacriticsPosClassicOn:
            result = re.sub('(?i)(?<!q)([ou])([aeoy])' + TONE + '(?!\\w)', "\\1\\3\\2", result)
        return unicodedata.normalize('NFC',result).replace('\u00D0', '\u0110').replace('\u00F0', '\u0111');

    def convertTextPortion(self, text):
        old = text.getString()
        new = None
        properties = {}
        fontName = text.getPropertyValue("CharFontName")
        logging.debug("processing text portion [%s] with font [%s]",
                                                        old, fontName)
        # XXX: sometime fontName==None ?!? see test file from IFI
        # XXX: manage situation where the fontname has got wrong letter case
        #      (eg: .vntime for .VnTime)
        if not fontName: return # XXX wrong wrong wrong

        if fontName.startswith('.Vn'):
            self.stats['vntime_tcvn'] += 1
            new = self.textConverter.convertString(old, 'vntime_tcvn',
                                            upper=fontName.endswith('H'))
            if fontName.startswith('.VnCourier New'):
                properties["CharFontName"] = "Courier New"
            elif fontName.startswith('.VnArial'):
                properties["CharFontName"] = "Arial"
            else:
                properties["CharFontName"] = "Times New Roman"
            properties["CharLocale"] = Locale('vi', 'VN', '')
        elif fontName.startswith('VNI'):
            self.stats['vni'] += 1
            new = self.textConverter.convertString(old, 'vni', upper=False)
            if fontName == 'VNI-Couri':
                properties["CharFontName"] = "Courier New"
            elif fontName == 'VNI-Arial':
                properties["CharFontName"] = "Arial"
            else:
                properties["CharFontName"] = "Times New Roman"
            properties["CharLocale"] = Locale('vi', 'VN', '')

        # remove diacritics as requested...
        if self.removeDiacriticsFlag:
            if new and new != old:
                new = self.textConverter.removeDiacritics(new)
            else:
                new = self.textConverter.removeDiacritics(old)
        else:
            #normalize diacritics
            if self.normalizeDiacriticsFlag:
                if new and new != old:
                    new = self.normalizeDiacritics(new,True)
                else:
                    new = self.normalizeDiacritics(old,True)
            else:
                if new and new != old:
                    new = self.normalizeDiacritics(new)
                else:
                    new = self.normalizeDiacritics(old)

        # FIXME: using setString makes loose all properties!!!
        # FIXME: may be use text.getPropertyValues() & text.setPropertyValues ??
        # TODO: - save _all_ properties into an array
        # TODO: - push additionnal properties if any
        # TODO: - update the text string content with setString
        # TODO: - reset properties from properties array
        if new and new != old:
            textStart = text.getStart()
            textEnd = text.getEnd()
            docText = textStart.getText()
            textCurs = docText.createTextCursorByRange(textStart)
            docText.insertString(textEnd, new, False)
            textCurs.goRight(len(old), True)
            textCurs.setString("")
            #text.setString(new)
            #text.String = new
        for k,v in list(properties.items()):
            text.setPropertyValue(k, v)

    def mostUsedEncoding(self):
        if self.stats['vntime_tcvn'] > self.stats['vni']:
            return 'vntime_tcvn'
        else:
            return 'vni'


class OOoDocumentParser(object):
    """OpenOffice.org and LibreOffice document parser."""

    def __init__(self, textPortionConverter=None):
        self.stats = { }
        self.setTextPortionConverter(textPortionConverter)

    def _reset_stats(self):
        self.stats['errors'] = 0

    def setTextPortionConverter(self, textPortionConverter):
        self._reset_stats()
        if textPortionConverter:
            self.textPortionConverter = textPortionConverter
            self.textConverter = textPortionConverter.textConverter
        else:
            self.textPortionConverter = None
            self.textConverter = None

    def processTextPortion(self, text):
        if not self.textPortionConverter:
            # TODO: shall we log that void processing?
            return
        try:
            self.textPortionConverter.convertTextPortion(text)
        except:
            logging.exception("Error during conversion:")
            self.stats['errors'] += 1
            if hasattr(text, 'CharBackColor'):
                text.setPropertyValue('CharBackColor', 0xFF0000)
            elif hasattr(text, 'CharColor'):
                text.setPropertyValue('CharColor', 0xFF0000)

    def processTextParagraph(self, paragraph):
        #logging.debug("dir(paragraph) = ( %s )", ' '.join(dir(paragraph)))
        #logging.debug("  services: %s", ', '.join(paragraph.getSupportedServiceNames()))
        #logging.debug("  hasElements: %s", paragraph.hasElements())
        enum = paragraph.createEnumeration()
        #logging.debug("dir(enum) = ( %s )", ' '.join(dir(enum)))
        # XXX: warning: text boundaries get altered when using setString
        #      with a longer string; should probably use a cursor here...
        while (enum.hasMoreElements()):
            textPortion = enum.nextElement()
            type = textPortion.getPropertyValue("TextPortionType")
            logging.debug("processing text paragraph element (type %s) [%s]",
                                                type, textPortion.getString())
            if type == 'Text':
                self.processTextPortion(textPortion)
            elif type == 'SoftPageBreak':
                pass
            elif type == 'Frame':
                # logging.debug("found a Frame (ignored, parsed later)")
                pass
            else:
                logging.warning("unknown text portion type '%s'", type)

    def processTextTable(self, table):
        for name in table.getCellNames():
            cell = table.getCellByName(name)
            self.processText(cell)

    def processText(self, text):
        enum = text.createEnumeration()
        while (enum.hasMoreElements()):
            paragraph = enum.nextElement()
            if paragraph.supportsService("com.sun.star.text.TextTable"):
                logging.debug("processing text element (table)")
                # this is a table "paragraph"
                self.processTextTable(paragraph)
            else:
                logging.debug("processing text element [%s]", paragraph.getString())
                # this is a text paragraph
                self.processTextParagraph(paragraph)

    def processTableShape(self, shape):
        model = shape.Model
        rows = model.RowCount
        columns = model.ColumnCount
        logging.debug("TableShape columns=%d & rows=%d", columns, rows)
        for row in range(rows):
            for column in range(columns):
                logging.debug("TableShape cell(col=%d,row=%d)", column, row)
                cell = model.getCellByPosition(column, row)
                self.processText(cell.Text)

    def processShape(self, shape):
        type = shape.getShapeType()
        if type == "com.sun.star.drawing.TextShape":
            self.processText(shape)
        elif type == "com.sun.star.drawing.GroupShape":
            for index in range(shape.getCount()):
                self.processShape(shape.getByIndex(index))
        elif type == "FrameShape":
            pass
        elif type == "com.sun.star.drawing.LineShape":
            pass
        #elif type == "com.sun.star.drawing.RectangleShape":
        #    pass
        elif type == "com.sun.star.drawing.CustomShape":
            self.processText(shape)
        elif type == "com.sun.star.drawing.TableShape":
            self.processTableShape(shape)
        elif type == "com.sun.star.presentation.TitleTextShape":
            self.processText(shape)
        elif type == "com.sun.star.presentation.SubtitleShape":
            self.processText(shape)
        elif type == "com.sun.star.presentation.OutlinerShape":
            self.processText(shape)
        else:
            logging.warning("unknown shape type '%s' for object named '%s'",
                                                            type, shape.Name)

    def processPageStyle(self, pageStyle):
        logging.debug("processing page style '%s'", pageStyle.Name)
        if pageStyle.HeaderIsOn:
            if pageStyle.HeaderText:
                self.processText(pageStyle.HeaderText)
            if pageStyle.HeaderTextLeft:
                self.processText(pageStyle.HeaderTextLeft)
            if pageStyle.HeaderTextRight:
                self.processText(pageStyle.HeaderTextRight)
        if pageStyle.FooterIsOn:
            if pageStyle.FooterText:
                self.processText(pageStyle.FooterText)
            if pageStyle.FooterTextLeft:
                self.processText(pageStyle.FooterTextLeft)
            if pageStyle.FooterTextRight:
                self.processText(pageStyle.FooterTextRight)

    def processTextDocument(self, doc):
        # convert text body
        text = doc.Text
        self.processText(text)
        # convert text frames
        frames = doc.getTextFrames()
        for index in range(frames.getCount()):
            frame = frames.getByIndex(index)
            self.processText(frame)
        # convert text shapes (in draw pages)
        drawPages = doc.getDrawPage()
        for index in range(drawPages.getCount()):
            drawPage = drawPages.getByIndex(index)
            self.processShape(drawPage)
        # convert text footnotes
        footnotes = doc.getFootnotes()
        for index in range(footnotes.getCount()):
            footnote = footnotes.getByIndex(index)
            logging.warning("found footnote '%s' (ignored)", footnote.Name)
            #logging.debug("dir(footnote) : %s", "|".join(dir(footnote)))
            #processText(footnote)
        # convert text sections
        sections = doc.getTextSections()
        #logging.debug("dir(sections) : %s", "|".join(dir(sections)))
        for index in range(sections.getCount()):
            section = sections.getByIndex(index)
            logging.warning("found section '%s' (ignored)", section.Name)
            #logging.debug("dir(section) : %s", "|".join(dir(section)))
            #processText(section)
        # CONVERT PAGE STYLES (mainly for text header & footer)
        pageStyles = doc.getStyleFamilies().getByName("PageStyles")
        for index in range(pageStyles.getCount()):
            pageStyle = pageStyles.getByIndex(index)
            logging.debug("found page style '%s'", pageStyle.Name)
            if pageStyle.isInUse():
                self.processPageStyle(pageStyle)

    def processSheet(self, sheet):
        cursor = sheet.createCursor()
        cursor.gotoEndOfUsedArea(False)
        cursor.gotoStartOfUsedArea(True)
        rangeAddress = cursor.getRangeAddress()
        rows = rangeAddress.EndRow - rangeAddress.StartRow + 2 #changed from 1 to 2 because of difference between sheet.getCellByPosition and cursor.getCellByPosition
        columns = rangeAddress.EndColumn - rangeAddress.StartColumn + 1
        logging.debug("Sheet columns=%d & rows=%d", columns, rows)
        for row in range(rows):
            for column in range(columns):
                logging.debug("Sheet cell(col=%d,row=%d)", column, row)
                cell = sheet.getCellByPosition(column, row)

                FORMULA = uno.Enum("com.sun.star.table.CellContentType", "FORMULA")
                VALUE = uno.Enum("com.sun.star.table.CellContentType", "VALUE")
                dataType = cell.getType()
                if dataType == VALUE:
                    cellvalue = cell.getValue()
                if dataType == FORMULA:
                    cellformular = cell.getFormula()

                self.processText(cell)

                if dataType == VALUE:
                    cell.setValue(cellvalue)
                if dataType == FORMULA:
                    cell.setFormula(cellformular)

    def processSpreadsheetDocument(self, doc):
        # disable automatic-calculation during process
        autoCalc = doc.isAutomaticCalculationEnabled()
        if autoCalc: doc.enableAutomaticCalculation(False)
        # process all sheets
        enum = doc.getSheets().createEnumeration()
        while (enum.hasMoreElements()):
            sheet = enum.nextElement()
            self.processSheet(sheet)
        # re-enable automatic-calculation if required
        if autoCalc: doc.enableAutomaticCalculation(True)

    def processDrawPresentationDocument(self, doc):
        # process all pages
        drawPages = doc.getDrawPages()
        for index in range(drawPages.getCount()):
            drawPage = drawPages.getByIndex(index)
            # convert page body
            logging.debug("converting draw page '%s'", drawPage.Name)
            for index in range(drawPage.getCount()):
                draw = drawPage.getByIndex(index)
                self.processShape(draw)
            # FIXME: should process text in drawPage.getNotesPage() too

            # FIXME: should detect if title has already been converted
            #        (by testing if it's valid Vietnamese word? argl...)
            # convert page name
            try:
                drawPage.setName(self.textConverter.convertString(
                            drawPage.Name,
                            self.textPortionConverter.mostUsedEncoding()))
            except:
                logging.info("unable to convert draw page name")
                pass # don't fail on this, since it's not that important

    def processDocument(self, doc):
        self._reset_stats()
        # XXX: check if it really works
        #doc.RecordChanges = False

        if doc.supportsService("com.sun.star.text.GenericTextDocument"):
            logging.info("this is a text document")
            self.processTextDocument(doc)
        elif doc.supportsService("com.sun.star.sheet.SpreadsheetDocument"):
            logging.info("this is a spreadsheet document")
            self.processSpreadsheetDocument(doc)
        elif doc.supportsService("com.sun.star.presentation.PresentationDocument"):
            logging.info("this is a presentation document")
            self.processDrawPresentationDocument(doc)
        elif doc.supportsService("com.sun.star.drawing.GenericDrawingDocument"):
            logging.info("this is a drawing document")
            self.processDrawPresentationDocument(doc)
        else:
            logging.warning("unknown document type")

        # convert document title
        # FIXME: should detect if title has already been converted
        #        (by testing if it's valid Vietnamese word? argl...)
        try:
            doc.Title = self.textConverter.convertString(doc.Title,
                            self.textPortionConverter.mostUsedEncoding())
        except:
            logging.info("unable to convert document title")
            pass # don't fail on this, since it's not that important

        # XXX: check if it really works
        #doc.RecordChanges = True

"""
B2UConverter — UNO extension for OpenOffice.org and LibreOffice
File: include/openoffice/extension_object.py

Copyright ©2009  Ministry of Science and Technology of Vietnam
License: GNU Lesser General Public License version 2.1
Authors: Jean Christophe André <jcandre@hanoilug.org>
         Lê Quốc Thái <lqthai@hanoilug.org>
         Võ Đức Phương <vdphuong@hanoilug.org>
         Hoàng Minh Thắng <hoangminhthang@ktqd.org>
"""

######################################################################

def B2UConverterScript(event=False):
    """Convert all document text segments from old Vietnamese encodings and fonts to Unicode encoding and fonts."""
    parser = OOoDocumentParser()
    vnConverter = VietnameseTextConverter(
        decoderPrefix='internal_',
        vniHacks=self._settings['VNIHacks'])
    oVnConverter = OOoVietnameseTextConverter(
        vnConverter,
        removeDiacritics=self._settings['RemoveDiacritics'],
        normalizeDiacritics=self._settings['NormalizeDiacritics'])
    parser.setTextPortionConverter(oVnConverter)
    return parser.processDocument(XSCRIPTCONTEXT.getDocument())

g_exportedScripts = B2UConverterScript,

######################################################################

#from com.sun.star.awt import Rectangle
from com.sun.star.awt import WindowDescriptor
from com.sun.star.awt.WindowClass import MODALTOP
from com.sun.star.awt.VclWindowPeerAttribute import OK, DEF_OK

# Show a message box with the UNO based toolkit
def messageBox(document, message):
    #doc = XSCRIPTCONTEXT.getDocument()
    window = document.CurrentController.Frame.ContainerWindow

    aDescriptor = WindowDescriptor()
    aDescriptor.Type = MODALTOP
    aDescriptor.WindowServiceName = "infobox"
    aDescriptor.ParentIndex = -1
    aDescriptor.Parent = window
    #aDescriptor.Bounds = Rectangle()
    aDescriptor.WindowAttributes = OK

    tk = window.getToolkit()
    msgbox = tk.createWindow(aDescriptor)
    msgbox.setCaptionText("Conversion to Unicode")
    msgbox.setMessageText(message)

    return msgbox.execute()

######################################################################

from com.sun.star.task import XJobExecutor
from com.sun.star.beans import PropertyValue
import os
from tempfile import mkstemp
from fnmatch import fnmatch

class B2UConverterJob(unohelper.Base, XJobExecutor):
    def __init__(self, context):
        self._context = context
        self._setupLogging()
        self.parser = OOoDocumentParser()

    def _readConfig(self):
        cfgprov = self._context.ServiceManager.createInstanceWithContext(
            "com.sun.star.configuration.ConfigurationProvider", self._context)
        node = PropertyValue()
        node.Name = "nodepath"
        node.Value = "/vn.gov.oss.openoffice.B2UConverter/General"
        ConfigReader = cfgprov.createInstanceWithArguments(
            "com.sun.star.configuration.ConfigurationAccess", (node,))
        cfgnames = ("Debug", "RemoveDiacritics", "NormalizeDiacritics", "VNIHacks",
            "LogFilename", "FolderConvertDefault", "FolderConvertPatterns")
        cfgvalues = ConfigReader.getPropertyValues(cfgnames)
        if not cfgvalues:
            raise RuntimeError("Unable to read the configuration.")
        self._settings = dict(list(zip(cfgnames, cfgvalues)))
        loglevel = (self._settings['Debug'] and logging.DEBUG or logging.INFO)
        logging.root.setLevel(loglevel)

    def _setupLogging(self):
        self._readConfig()
        filename = self._settings.get('LogFilename')
        if not filename: filename = '~/.B2UConverter-OOo.log'
        old_umask = os.umask(0o077)
        # TODO: check if it fails and take countermesure in this case
        logging.basicConfig(
            format='%(asctime)s %(levelname)s %(message)s',
            filename=os.path.expanduser(filename),
            filemode='w')
        os.umask(old_umask)
        logging.info("B2UConverter loaded (Python %s)", sys.version)
        logging.debug("Settings: %s", self._settings)

    def _error_message(self, error_count):
        if error_count > 1:
            message = "with %s errors" % error_count
        elif error_count > 0:
            message = "with %s error" % error_count
        else:
            message = "without error"
        return message

    def convertFolder(self):
        """Recursively convert the entire folder
        by letting user select a folder to convert (file browser)
        Traverse the given folder
        """
        folder = self._chooseFolder(self._settings['FolderConvertDefault'])
        if not folder: # User clicked on the Cancel button
            return
        logging.debug("Converting folder: %s", folder)

        patterns = self._settings['FolderConvertPatterns']
        if not patterns: patterns = '*.doc;*.xls;*.ppt'
        # a Desktop implements XComponentLoader interface
        self._convertDocByDoc(folder, patterns, self._desktop)
        # FIXME: A summary dialog once conversion done

    def _convertDocByDoc(self, folder, patterns, xLoader):
        """Traverse a folder and convert all supported documents (ODT, ODP, etc.)
        Apply filtering to all files retrieved
        Convert each document, save & close
        """
        loadProp = PropertyValue()
        loadProp.Name = "Hidden"
        loadProp.Value = True

        for path in self._findFiles(folder, patterns):
            url = unohelper.systemPathToFileUrl(path)
            doc = xLoader.loadComponentFromURL(url, "_blank", 0, (loadProp,))
            self.convertDocument(doc)
            # It's wiser choice to save & close one document
            # at once before processing the next
            try:
                doc.store()
            finally:
                # XXX: this could generate an exception too
                try:
                    doc.close(True)
                except:
                    logging.exception("Exception closing document '%s'", url)

    def _findFiles(self, root, patterns='*'):
        """
        Recursively get all supported documents (text, slides, spreadsheet)
        under a given folder (param 'root')
        """
        # Expand patterns from semicolon-separated string to list
        patterns = patterns.split(';')
        for path, subdirs, files in os.walk(root):
            #files.sort( )
            for name in files:
                # TODO: apply a file pattern to filter supported document formats
                for pattern in patterns:
                    if fnmatch(name, pattern):
                        yield os.path.join(path, name)
                        break

    def _chooseFolder(self, folder="~/B2UConverter"):
        folder = unohelper.systemPathToFileUrl(os.path.expanduser(folder))
        folderPicker = self._context.ServiceManager.createInstanceWithContext(
            "com.sun.star.ui.dialogs.OfficeFolderPicker", self._context)
        folderPicker.setDisplayDirectory(folder)
        if folderPicker.execute():
            selectedFolder = folderPicker.getDirectory()
            selectedFolder = unohelper.fileUrlToSystemPath(selectedFolder)
        else:
            selectedFolder = None # Cancel button pressed
        return selectedFolder

    def convertDocument(self, document=None):
        logging.debug("call to convertDocument (%s document)" \
                                % (document and "given" or "current"))
        if not document:
            document = self._document
        self.parser.processDocument(document)
        errmsg = self._error_message(self.parser.stats['errors'])
        logging.info("Conversion completed (%s).", errmsg)

    def convertClipboard(self):
        logging.debug("call to convertClipboard")

        # Get the contents from the clipboard, try to extract the data using
        # OpenOffice.org XML flavor
        clipboard = self._context.ServiceManager.createInstanceWithContext(
            "com.sun.star.datatransfer.clipboard.SystemClipboard",
            self._context)
        contents = clipboard.getContents()
        flavors = contents.getTransferDataFlavors()
        logging.debug("Clipboard flavors:\n%s",
                "* " + "\n* ".join([flavor.MimeType for flavor in flavors]))

        # TODO: Adding support for more flavors like richtext or plaintext
        mimetype = 'application/x-openoffice-embed-source-xml' \
                    ';windows_formatname="Star Embed Source (XML)"'
        found_flavor = None
        for flavor in flavors:
            if flavor.MimeType == mimetype:
                found_flavor = flavor
                break

        # FIXME: No suitable flavor found, warn user that nothing has been
        # converted
        # if found_flavor == None:
        data = contents.getTransferData(found_flavor)

        # Okay, since OO.o APIs only accept an URL, we have to make a temp file
        # in order to use it.
        tempFile,path = mkstemp()
        os.write(tempFile, data.value)
        tempURL = unohelper.systemPathToFileUrl(path)

        # Open it hiddenly
        hidden = PropertyValue()
        hidden.Name = "Hidden"
        hidden.Value = True
        document = self._desktop.loadComponentFromURL(
                                            tempURL, "_blank", 0, (hidden,))

        # Let process it
        # TODO: Improve encoding detection so we can convert even if the
        # supplied font information is incorrect.
        self.parser.processDocument(document)

        # Ok, now to put it back in the clipboard
        dispatcher = self._context.ServiceManager.createInstanceWithContext(
                        "com.sun.star.frame.DispatchHelper", self._context)
        frame = document.getCurrentController().getFrame()
        dispatcher.executeDispatch(frame, ".uno:SelectAll", "", 0, ())
        dispatcher.executeDispatch(frame, ".uno:Copy", "", 0, ())

        # Some clean ups
        document.close(True)
        os.close(tempFile)
        os.unlink(path)

    def convertSelection(self):
        pass

    def trigger(self, args):
        # preparing environment
        self._readConfig()
        self._desktop = self._context.ServiceManager.createInstanceWithContext(
                                "com.sun.star.frame.Desktop", self._context)
        self._document = self._desktop.getCurrentComponent()

        # preparing converter
        vnConverter = VietnameseTextConverter(
            decoderPrefix='internal_', vniHacks=self._settings['VNIHacks'])
        oVnConverter = OOoVietnameseTextConverter(
            vnConverter, removeDiacritics=self._settings['RemoveDiacritics'], normalizeDiacritics=self._settings['NormalizeDiacritics'])
        self.parser.setTextPortionConverter(oVnConverter)

        # running requested operation
        logging.debug("Trigger arguments: %s", args)
        try:
            if args == 'document':
                self.convertDocument()
            elif args == 'clipboard':
                self.convertClipboard()
            elif args == 'selection':
                self.convertSelection()
            elif args == 'folder':
                self.convertFolder()
            else:
                raise ValueError("Invalid trigger call (programming error).")
            errmsg = self._error_message(self.parser.stats['errors'])
            logging.info("Conversion completed (%s).", errmsg)
            messageBox(self._document, "Conversion completed (%s)." % errmsg)
        except:
            logging.exception("Exception during conversion:")
            err = traceback.format_exc()
            try:
                import re
                err = re.sub('File "([^"]*/)+','File ".../', err)
            except:
                pass
            messageBox(self._document, "Conversion failed:\n\n" + err)


g_ImplementationHelper = unohelper.ImplementationHelper()
g_ImplementationHelper.addImplementation( \
    B2UConverterJob, "vn.gov.oss.openoffice.B2UConverterJob", \
    ("com.sun.star.task.Job",),)
